<?php

/*****************************************************************
 We execute this section if the "Display in Browser"
 button is clicked.
*****************************************************************/

set_time_limit($DEF_TIME_LIMIT);

$defaultStart="*nat\n";

$defaultEnd="COMMIT\n";

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>iptables country blocking code</title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
</head>
<body>
<pre>
<?php

// Add the beginning from the "defaultrules" file if it exists.
$defRules=0;
$endOfDefRules=1;
if (file_exists($DEF_IPT_RULES)) {
	if (($defhandle = fopen($DEF_IPT_RULES, "r")) ==FALSE) {
		errorExit("Unable to read from file: $DEF_IPT_RULES");
	}
	$defRules=1;
	$endOfDefRules=0;
	while (true) {
		$defruleline = fgets($defhandle, 256);
		if ($defruleline=="") { $endOfDefRules=1; break; }
		if ($defruleline[0]<>"\x23") {
			$teststring=substr($defruleline, 0, 4 );
			if (($teststring=="*nat") || ($teststring=="*NAT")) {
				break;
			} else {
				print $defruleline;
			}
		}
	}
}

print $defaultStart;
if ($defRules) {
	if ($endOfDefRules==0) {
		$defruleline = fgets($defhandle, 256);
		print $defruleline;
		$defruleline = fgets($defhandle, 256);
		print $defruleline;
		$defruleline = fgets($defhandle, 256);
		print $defruleline;
	}
}

$rangeCount=0;

do {

	if (file_exists($rangeCount.".php")) {
		include($rangeCount.".php");
	} else {
		errorExit("Database file not found: ($iptablesfilename)");
	}

// Add content to the data that is sent.

if ($eth=="other") {
	$ethBlock=$ethOther;
} else {
	$ethBlock=$eth;
}

if ($ethmethod==1) {
	$icommand="-i ! ".$ethBlock;
} else {
	$icommand="-i ".$ethBlock;
}
$oldRange="";
$startFound=0;
$iptext="-I PREROUTING $icommand -m iprange --src-range";

foreach($ranges as $key => $value) {
	if (ckifbadcountry($ranges[$key][1])=="BAD") {
		$rangehigh=dectodot($ranges[$key][0]);
		if ($startFound==0) {
			$rangelow=dectodot($key);
			$startFound=1;
		}
	} else {
		if ($startFound) {
			$startFound=0;
			$range="$rangelow-$rangehigh";
			if ("$range"<>"$oldRange") {
				$oldRange="$range";
				if ($kernels == "newer") {
					$iptablesline="$iptext $range -j DNAT --to 0\n";
				} else {
					$iptablesline="$iptext $range -j DROP\n";
				}
				print $iptablesline;
			}
		}
	}
}

if ($startFound) {
	$startFound=0;
	$range="$rangelow-$rangehigh";
	if ("$range"<>"$oldRange") {
		$oldRange="$range";
		if ($kernels == "newer") {
			$iptablesline="$iptext $range -j DNAT --to 0\n";
		} else {
			$iptablesline="$iptext $range -j DROP\n";
		}
		print $iptablesline;
	}
}

$rangeCount+=1;

} while ($rangeCount<256);


if (($endOfDefRules) || ($defRules==0)) {
	print $defaultEnd;
}

if (($defRules) && ($endOfDefRules==0)) {
	while (true) {
		$defruleline = fgets($defhandle, 256);
		if ($defruleline=="") { break; }
		if ($defruleline[0]<>"\x23") {
			print $defruleline;
		}
	}
}

// Close the files.
if ($defRules) { fclose($defhandle); }

?>
</pre>
</body>
</html>
